' HtmFname.VBS V1.09 (C) yoshioka.teruo@nifty.com 2007-02-11
' HtmFname.VBS renames htmfile to "title.html"
' Usage: Start HtmFname.VBS htmfiles...

Option Explicit
Const adTypeText=2
Dim fso
Dim RE
Dim Matches
Dim arg
Dim File
Dim ExtensionName
Dim FileName
Dim Stream
Dim charset
Dim Title
Dim n
Dim Text

Set fso=CreateObject("Scripting.FileSystemObject")
Set RE=new RegExp
RE.IgnoreCase=True

For Each arg In WScript.Arguments
  Set File=fso.GetFile(arg)
  ExtensionName=fso.GetExtensionName(File.Name)
  Select Case UCase(ExtensionName)
  Case "HTM"
  Case "HTML"
  Case Else
    FileName=fso.GetBaseName(File.Name) & ".html"
    FileName=InputBox("Unknown Extension Name: " & ExtensionName & vbLf & "Enter New Name",File.Name,FileName)
    If FileName<>"" Then
      File.Name=FileName
      ExtensionName=fso.GetExtensionName(File.Name)
    Else
      WScript.Quit
    End If
  End Select

  Set Stream=File.OpenAsTextStream()
  Text=ReadAll(Stream)
  Stream.Close()
  RE.Pattern="<META\s+[^>]*charset\s*=\s*([-A-Za-z0-9_]+)"
  RE.Global=False
  Set Matches=RE.Execute(Text)
  If Matches.Count Then
    charset=Matches.Item(0).SubMatches.Item(0)
  Else
    charset=""
  End If

  Select Case(LCase(charset))
  Case "x-sjis","shift_jis","iso-8859-1",""
    Set Stream=File.OpenAsTextStream(,vbUseDefault)
    Text=ReadAll(Stream)
    Stream.Close
  Case Else
    Set Stream=CreateObject("ADODB.Stream")
    Stream.Open
    Stream.Type=adTypeText
    Stream.Charset=charset
    Stream.LoadFromFile File.Path
    Text=Stream.ReadText(-1)
    Stream.Close
    Set Stream=Nothing
  End Select

  RE.Pattern="<title\b[^>]*>([^<]*)</title>"
  RE.Global=False
  Set Matches=RE.Execute(Text)
  If Matches.Count Then
    Title=Matches.Item(0).SubMatches.Item(0)
  Else
    Title=""
  End If
  If Title<>"" Then
    Title=Replace(Title,"\","")
    Title=Replace(Title,"/","^")
    Title=Replace(Title,":","F")
    Title=Replace(Title,"*","")
    Title=Replace(Title,"?","H")
    Title=Replace(Title,"""","h")
    Title=Replace(Title,"<","")
    Title=Replace(Title,">","")
    Title=Replace(Title,"|","b")
    Title=Replace(Title,"&amp;","")
    RE.Pattern="\s+"
    RE.Global=True
    Title=RE.Replace(Title," ")
    Title=Trim(Title)
  End If
  FileName=Title & "." & ExtensionName
  FileName=InputBox("Enter New Name",File.Name,FileName)
  n=1
  Do While FileName<>""
    Call Rename(File,FileName)
    If Err=0 Then
      FileName=""
    ElseIf Err=58 Then
      n=n+1
      FileName=Title & " " & n & "." & ExtensionName
      FileName=InputBox(Err.Number & ":" & Err.Description & "Re-Enter New Name",File.Name,FileName)
    Else
      FileName=InputBox(Err.Number & ":" & Err.Description & "Re-Enter New Name",File.Name,FileName)
    End If
  Loop

  If InStr(Text,vbNullChar) Then
    MsgBox "Warning! NUL char found. Remove it later.",vbExclamation,File.Name
  End If
  If InStr(Text,vbCr & vbCrLf) Then
    MsgBox "Warning! CR+CR+LF found. Fix it later.",vbExclamation,File.Name
  End If
  Select Case(LCase(charset))
  Case "x-sjis","shift_jis",""
  Case Else
    MsgBox "Warning! CharSet is "&charset,vbExclamation,File.Name
  End Select
Next
WScript.Quit

Sub Rename(File,Name)
On Error Resume Next
File.Name=Name
End Sub

Function ReadAll(Stream)
Do While Not Stream.AtEndOfStream
  ReadAll=ReadAll & Stream.Read(4096)
Loop
End Function
